// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package clusters

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// PutClustersReader is a Reader for the PutClusters structure.
type PutClustersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutClustersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutClustersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutClustersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutClustersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutClustersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutClustersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutClustersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutClustersOK creates a PutClustersOK with default headers values
func NewPutClustersOK() *PutClustersOK {
	return &PutClustersOK{}
}

/*
PutClustersOK describes a response with status code 200, with default header values.

Response with Cluster objects
*/
type PutClustersOK struct {
	Payload *members_models.ClusterResponse
}

// IsSuccess returns true when this put clusters o k response has a 2xx status code
func (o *PutClustersOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this put clusters o k response has a 3xx status code
func (o *PutClustersOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put clusters o k response has a 4xx status code
func (o *PutClustersOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this put clusters o k response has a 5xx status code
func (o *PutClustersOK) IsServerError() bool {
	return false
}

// IsCode returns true when this put clusters o k response a status code equal to that given
func (o *PutClustersOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the put clusters o k response
func (o *PutClustersOK) Code() int {
	return 200
}

func (o *PutClustersOK) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersOK  %+v", 200, o.Payload)
}

func (o *PutClustersOK) String() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersOK  %+v", 200, o.Payload)
}

func (o *PutClustersOK) GetPayload() *members_models.ClusterResponse {
	return o.Payload
}

func (o *PutClustersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.ClusterResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutClustersUnauthorized creates a PutClustersUnauthorized with default headers values
func NewPutClustersUnauthorized() *PutClustersUnauthorized {
	return &PutClustersUnauthorized{}
}

/*
PutClustersUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutClustersUnauthorized struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this put clusters unauthorized response has a 2xx status code
func (o *PutClustersUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put clusters unauthorized response has a 3xx status code
func (o *PutClustersUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put clusters unauthorized response has a 4xx status code
func (o *PutClustersUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this put clusters unauthorized response has a 5xx status code
func (o *PutClustersUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this put clusters unauthorized response a status code equal to that given
func (o *PutClustersUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the put clusters unauthorized response
func (o *PutClustersUnauthorized) Code() int {
	return 401
}

func (o *PutClustersUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersUnauthorized  %+v", 401, o.Payload)
}

func (o *PutClustersUnauthorized) String() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersUnauthorized  %+v", 401, o.Payload)
}

func (o *PutClustersUnauthorized) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PutClustersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutClustersForbidden creates a PutClustersForbidden with default headers values
func NewPutClustersForbidden() *PutClustersForbidden {
	return &PutClustersForbidden{}
}

/*
PutClustersForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutClustersForbidden struct {
	AccessControlAllowOrigin string

	Payload *members_models.Error
}

// IsSuccess returns true when this put clusters forbidden response has a 2xx status code
func (o *PutClustersForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put clusters forbidden response has a 3xx status code
func (o *PutClustersForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put clusters forbidden response has a 4xx status code
func (o *PutClustersForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this put clusters forbidden response has a 5xx status code
func (o *PutClustersForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this put clusters forbidden response a status code equal to that given
func (o *PutClustersForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the put clusters forbidden response
func (o *PutClustersForbidden) Code() int {
	return 403
}

func (o *PutClustersForbidden) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersForbidden  %+v", 403, o.Payload)
}

func (o *PutClustersForbidden) String() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersForbidden  %+v", 403, o.Payload)
}

func (o *PutClustersForbidden) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PutClustersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutClustersNotFound creates a PutClustersNotFound with default headers values
func NewPutClustersNotFound() *PutClustersNotFound {
	return &PutClustersNotFound{}
}

/*
PutClustersNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutClustersNotFound struct {
	AccessControlAllowOrigin string

	Payload *members_models.Error
}

// IsSuccess returns true when this put clusters not found response has a 2xx status code
func (o *PutClustersNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put clusters not found response has a 3xx status code
func (o *PutClustersNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put clusters not found response has a 4xx status code
func (o *PutClustersNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this put clusters not found response has a 5xx status code
func (o *PutClustersNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this put clusters not found response a status code equal to that given
func (o *PutClustersNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the put clusters not found response
func (o *PutClustersNotFound) Code() int {
	return 404
}

func (o *PutClustersNotFound) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersNotFound  %+v", 404, o.Payload)
}

func (o *PutClustersNotFound) String() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersNotFound  %+v", 404, o.Payload)
}

func (o *PutClustersNotFound) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PutClustersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutClustersUnprocessableEntity creates a PutClustersUnprocessableEntity with default headers values
func NewPutClustersUnprocessableEntity() *PutClustersUnprocessableEntity {
	return &PutClustersUnprocessableEntity{}
}

/*
PutClustersUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutClustersUnprocessableEntity struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this put clusters unprocessable entity response has a 2xx status code
func (o *PutClustersUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put clusters unprocessable entity response has a 3xx status code
func (o *PutClustersUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put clusters unprocessable entity response has a 4xx status code
func (o *PutClustersUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this put clusters unprocessable entity response has a 5xx status code
func (o *PutClustersUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this put clusters unprocessable entity response a status code equal to that given
func (o *PutClustersUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the put clusters unprocessable entity response
func (o *PutClustersUnprocessableEntity) Code() int {
	return 422
}

func (o *PutClustersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutClustersUnprocessableEntity) String() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutClustersUnprocessableEntity) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PutClustersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutClustersInternalServerError creates a PutClustersInternalServerError with default headers values
func NewPutClustersInternalServerError() *PutClustersInternalServerError {
	return &PutClustersInternalServerError{}
}

/*
PutClustersInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutClustersInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *members_models.Error
}

// IsSuccess returns true when this put clusters internal server error response has a 2xx status code
func (o *PutClustersInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put clusters internal server error response has a 3xx status code
func (o *PutClustersInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put clusters internal server error response has a 4xx status code
func (o *PutClustersInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this put clusters internal server error response has a 5xx status code
func (o *PutClustersInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this put clusters internal server error response a status code equal to that given
func (o *PutClustersInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the put clusters internal server error response
func (o *PutClustersInternalServerError) Code() int {
	return 500
}

func (o *PutClustersInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersInternalServerError  %+v", 500, o.Payload)
}

func (o *PutClustersInternalServerError) String() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersInternalServerError  %+v", 500, o.Payload)
}

func (o *PutClustersInternalServerError) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PutClustersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
