// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package databases

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// PutDatabasesReader is a Reader for the PutDatabases structure.
type PutDatabasesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutDatabasesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutDatabasesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutDatabasesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutDatabasesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutDatabasesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutDatabasesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutDatabasesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutDatabasesOK creates a PutDatabasesOK with default headers values
func NewPutDatabasesOK() *PutDatabasesOK {
	return &PutDatabasesOK{}
}

/*
PutDatabasesOK describes a response with status code 200, with default header values.

Response with Database objects
*/
type PutDatabasesOK struct {
	AccessControlAllowOrigin string

	Payload *members_models.DatabaseResponse
}

// IsSuccess returns true when this put databases o k response has a 2xx status code
func (o *PutDatabasesOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this put databases o k response has a 3xx status code
func (o *PutDatabasesOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put databases o k response has a 4xx status code
func (o *PutDatabasesOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this put databases o k response has a 5xx status code
func (o *PutDatabasesOK) IsServerError() bool {
	return false
}

// IsCode returns true when this put databases o k response a status code equal to that given
func (o *PutDatabasesOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the put databases o k response
func (o *PutDatabasesOK) Code() int {
	return 200
}

func (o *PutDatabasesOK) Error() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesOK  %+v", 200, o.Payload)
}

func (o *PutDatabasesOK) String() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesOK  %+v", 200, o.Payload)
}

func (o *PutDatabasesOK) GetPayload() *members_models.DatabaseResponse {
	return o.Payload
}

func (o *PutDatabasesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.DatabaseResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutDatabasesUnauthorized creates a PutDatabasesUnauthorized with default headers values
func NewPutDatabasesUnauthorized() *PutDatabasesUnauthorized {
	return &PutDatabasesUnauthorized{}
}

/*
PutDatabasesUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutDatabasesUnauthorized struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this put databases unauthorized response has a 2xx status code
func (o *PutDatabasesUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put databases unauthorized response has a 3xx status code
func (o *PutDatabasesUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put databases unauthorized response has a 4xx status code
func (o *PutDatabasesUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this put databases unauthorized response has a 5xx status code
func (o *PutDatabasesUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this put databases unauthorized response a status code equal to that given
func (o *PutDatabasesUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the put databases unauthorized response
func (o *PutDatabasesUnauthorized) Code() int {
	return 401
}

func (o *PutDatabasesUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesUnauthorized  %+v", 401, o.Payload)
}

func (o *PutDatabasesUnauthorized) String() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesUnauthorized  %+v", 401, o.Payload)
}

func (o *PutDatabasesUnauthorized) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PutDatabasesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutDatabasesForbidden creates a PutDatabasesForbidden with default headers values
func NewPutDatabasesForbidden() *PutDatabasesForbidden {
	return &PutDatabasesForbidden{}
}

/*
PutDatabasesForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutDatabasesForbidden struct {
	AccessControlAllowOrigin string

	Payload *members_models.Error
}

// IsSuccess returns true when this put databases forbidden response has a 2xx status code
func (o *PutDatabasesForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put databases forbidden response has a 3xx status code
func (o *PutDatabasesForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put databases forbidden response has a 4xx status code
func (o *PutDatabasesForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this put databases forbidden response has a 5xx status code
func (o *PutDatabasesForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this put databases forbidden response a status code equal to that given
func (o *PutDatabasesForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the put databases forbidden response
func (o *PutDatabasesForbidden) Code() int {
	return 403
}

func (o *PutDatabasesForbidden) Error() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesForbidden  %+v", 403, o.Payload)
}

func (o *PutDatabasesForbidden) String() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesForbidden  %+v", 403, o.Payload)
}

func (o *PutDatabasesForbidden) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PutDatabasesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutDatabasesNotFound creates a PutDatabasesNotFound with default headers values
func NewPutDatabasesNotFound() *PutDatabasesNotFound {
	return &PutDatabasesNotFound{}
}

/*
PutDatabasesNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutDatabasesNotFound struct {
	AccessControlAllowOrigin string

	Payload *members_models.Error
}

// IsSuccess returns true when this put databases not found response has a 2xx status code
func (o *PutDatabasesNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put databases not found response has a 3xx status code
func (o *PutDatabasesNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put databases not found response has a 4xx status code
func (o *PutDatabasesNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this put databases not found response has a 5xx status code
func (o *PutDatabasesNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this put databases not found response a status code equal to that given
func (o *PutDatabasesNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the put databases not found response
func (o *PutDatabasesNotFound) Code() int {
	return 404
}

func (o *PutDatabasesNotFound) Error() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesNotFound  %+v", 404, o.Payload)
}

func (o *PutDatabasesNotFound) String() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesNotFound  %+v", 404, o.Payload)
}

func (o *PutDatabasesNotFound) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PutDatabasesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutDatabasesUnprocessableEntity creates a PutDatabasesUnprocessableEntity with default headers values
func NewPutDatabasesUnprocessableEntity() *PutDatabasesUnprocessableEntity {
	return &PutDatabasesUnprocessableEntity{}
}

/*
PutDatabasesUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutDatabasesUnprocessableEntity struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this put databases unprocessable entity response has a 2xx status code
func (o *PutDatabasesUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put databases unprocessable entity response has a 3xx status code
func (o *PutDatabasesUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put databases unprocessable entity response has a 4xx status code
func (o *PutDatabasesUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this put databases unprocessable entity response has a 5xx status code
func (o *PutDatabasesUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this put databases unprocessable entity response a status code equal to that given
func (o *PutDatabasesUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the put databases unprocessable entity response
func (o *PutDatabasesUnprocessableEntity) Code() int {
	return 422
}

func (o *PutDatabasesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutDatabasesUnprocessableEntity) String() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutDatabasesUnprocessableEntity) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PutDatabasesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutDatabasesInternalServerError creates a PutDatabasesInternalServerError with default headers values
func NewPutDatabasesInternalServerError() *PutDatabasesInternalServerError {
	return &PutDatabasesInternalServerError{}
}

/*
PutDatabasesInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutDatabasesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *members_models.Error
}

// IsSuccess returns true when this put databases internal server error response has a 2xx status code
func (o *PutDatabasesInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put databases internal server error response has a 3xx status code
func (o *PutDatabasesInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put databases internal server error response has a 4xx status code
func (o *PutDatabasesInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this put databases internal server error response has a 5xx status code
func (o *PutDatabasesInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this put databases internal server error response a status code equal to that given
func (o *PutDatabasesInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the put databases internal server error response
func (o *PutDatabasesInternalServerError) Code() int {
	return 500
}

func (o *PutDatabasesInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesInternalServerError  %+v", 500, o.Payload)
}

func (o *PutDatabasesInternalServerError) String() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesInternalServerError  %+v", 500, o.Payload)
}

func (o *PutDatabasesInternalServerError) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PutDatabasesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
