// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package research_project_companies

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new research project companies API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for research project companies API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	CreateResearchProjectCompany(params *CreateResearchProjectCompanyParams, opts ...ClientOption) (*CreateResearchProjectCompanyCreated, error)

	DeleteResearchProjectCompany(params *DeleteResearchProjectCompanyParams, opts ...ClientOption) (*DeleteResearchProjectCompanyNoContent, error)

	GetResearchProjectCompanies(params *GetResearchProjectCompaniesParams, opts ...ClientOption) (*GetResearchProjectCompaniesOK, error)

	UpdateResearchProjectCompany(params *UpdateResearchProjectCompanyParams, opts ...ClientOption) (*UpdateResearchProjectCompanyOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
CreateResearchProjectCompany creates a new research project company
*/
func (a *Client) CreateResearchProjectCompany(params *CreateResearchProjectCompanyParams, opts ...ClientOption) (*CreateResearchProjectCompanyCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewCreateResearchProjectCompanyParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "createResearchProjectCompany",
		Method:             "POST",
		PathPattern:        "/researchprojectcompanys",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &CreateResearchProjectCompanyReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*CreateResearchProjectCompanyCreated)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for createResearchProjectCompany: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
DeleteResearchProjectCompany deletes a research project company
*/
func (a *Client) DeleteResearchProjectCompany(params *DeleteResearchProjectCompanyParams, opts ...ClientOption) (*DeleteResearchProjectCompanyNoContent, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteResearchProjectCompanyParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "deleteResearchProjectCompany",
		Method:             "DELETE",
		PathPattern:        "/researchprojectcompanys",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &DeleteResearchProjectCompanyReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DeleteResearchProjectCompanyNoContent)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for deleteResearchProjectCompany: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
GetResearchProjectCompanies gets a list of research project companies
*/
func (a *Client) GetResearchProjectCompanies(params *GetResearchProjectCompaniesParams, opts ...ClientOption) (*GetResearchProjectCompaniesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetResearchProjectCompaniesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getResearchProjectCompanies",
		Method:             "GET",
		PathPattern:        "/researchprojectcompanys",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetResearchProjectCompaniesReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetResearchProjectCompaniesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getResearchProjectCompanies: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
UpdateResearchProjectCompany updates an existing research project company
*/
func (a *Client) UpdateResearchProjectCompany(params *UpdateResearchProjectCompanyParams, opts ...ClientOption) (*UpdateResearchProjectCompanyOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewUpdateResearchProjectCompanyParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "updateResearchProjectCompany",
		Method:             "PUT",
		PathPattern:        "/researchprojectcompanys",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &UpdateResearchProjectCompanyReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*UpdateResearchProjectCompanyOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for updateResearchProjectCompany: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
