// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tenants

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// NewPostTenantsParams creates a new PostTenantsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostTenantsParams() *PostTenantsParams {
	return &PostTenantsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostTenantsParamsWithTimeout creates a new PostTenantsParams object
// with the ability to set a timeout on a request.
func NewPostTenantsParamsWithTimeout(timeout time.Duration) *PostTenantsParams {
	return &PostTenantsParams{
		timeout: timeout,
	}
}

// NewPostTenantsParamsWithContext creates a new PostTenantsParams object
// with the ability to set a context for a request.
func NewPostTenantsParamsWithContext(ctx context.Context) *PostTenantsParams {
	return &PostTenantsParams{
		Context: ctx,
	}
}

// NewPostTenantsParamsWithHTTPClient creates a new PostTenantsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostTenantsParamsWithHTTPClient(client *http.Client) *PostTenantsParams {
	return &PostTenantsParams{
		HTTPClient: client,
	}
}

/*
PostTenantsParams contains all the parameters to send to the API endpoint

	for the post tenants operation.

	Typically these are written to a http.Request.
*/
type PostTenantsParams struct {

	/* TenantRequest.

	   An array of Tenant records
	*/
	TenantRequest *members_models.TenantRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post tenants params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostTenantsParams) WithDefaults() *PostTenantsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post tenants params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostTenantsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post tenants params
func (o *PostTenantsParams) WithTimeout(timeout time.Duration) *PostTenantsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post tenants params
func (o *PostTenantsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post tenants params
func (o *PostTenantsParams) WithContext(ctx context.Context) *PostTenantsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post tenants params
func (o *PostTenantsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post tenants params
func (o *PostTenantsParams) WithHTTPClient(client *http.Client) *PostTenantsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post tenants params
func (o *PostTenantsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithTenantRequest adds the tenantRequest to the post tenants params
func (o *PostTenantsParams) WithTenantRequest(tenantRequest *members_models.TenantRequest) *PostTenantsParams {
	o.SetTenantRequest(tenantRequest)
	return o
}

// SetTenantRequest adds the tenantRequest to the post tenants params
func (o *PostTenantsParams) SetTenantRequest(tenantRequest *members_models.TenantRequest) {
	o.TenantRequest = tenantRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostTenantsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.TenantRequest != nil {
		if err := r.SetBodyParam(o.TenantRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
