// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package financial_statements

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new financial statements API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for financial statements API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	DeleteFinancialStatement(params *DeleteFinancialStatementParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*DeleteFinancialStatementOK, error)

	GetFinancialStatements(params *GetFinancialStatementsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetFinancialStatementsOK, error)

	PostFinancialStatements(params *PostFinancialStatementsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostFinancialStatementsOK, error)

	PutFinancialStatement(params *PutFinancialStatementParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutFinancialStatementOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
DeleteFinancialStatement deletes an financial statement

Delete FinancialStatement record
*/
func (a *Client) DeleteFinancialStatement(params *DeleteFinancialStatementParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*DeleteFinancialStatementOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteFinancialStatementParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "deleteFinancialStatement",
		Method:             "DELETE",
		PathPattern:        "/financialstatements",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &DeleteFinancialStatementReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DeleteFinancialStatementOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for deleteFinancialStatement: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
GetFinancialStatements gets a list of financial statements

Return a list of all available FinancialStatements
*/
func (a *Client) GetFinancialStatements(params *GetFinancialStatementsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetFinancialStatementsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetFinancialStatementsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getFinancialStatements",
		Method:             "GET",
		PathPattern:        "/financialstatements",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetFinancialStatementsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetFinancialStatementsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getFinancialStatements: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PostFinancialStatements adds a new financial statement to salesforce devops net

FinancialStatement records to be added
*/
func (a *Client) PostFinancialStatements(params *PostFinancialStatementsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostFinancialStatementsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostFinancialStatementsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postFinancialStatements",
		Method:             "POST",
		PathPattern:        "/financialstatements",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostFinancialStatementsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostFinancialStatementsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postFinancialStatements: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PutFinancialStatement updates financial statement records

Update financialStatement records
*/
func (a *Client) PutFinancialStatement(params *PutFinancialStatementParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutFinancialStatementOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutFinancialStatementParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "putFinancialStatement",
		Method:             "PUT",
		PathPattern:        "/financialstatements",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutFinancialStatementReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutFinancialStatementOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putFinancialStatement: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
